#include "types.h"                  
#include "lpc17xx.h"                  
#include "hal_host_if.h"    
#include "hal_serial.h"   



/*****************************************************************************
** 
** 
*****************************************************************************/
int hal_host_if_init(void)
{
	LPC_GPIO4->FIOSET = PINMASK(PIN_WR);
	LPC_GPIO2->FIOSET = PINMASK(PIN_RD);
    
    return 0;
}

/*****************************************************************************
** 
** 
*****************************************************************************/
int hal_host_if_send(const char*BufferPtr, U32 Length )
{
	U32 					cnt    = 0;
	LPC_GPIO_TypeDef 	*	pGPIO2 = LPC_GPIO2;
	LPC_GPIO_TypeDef 	*	pGPIO4 = LPC_GPIO4;

    {
    	while(cnt < Length)
    	{
    		while( ( (pGPIO2->FIOPIN & PINMASK(PIN_TXE)) == 0) && (cnt < Length) )
    		{
    			pGPIO4->FIOSET = PINMASK(PIN_WR);
    			pGPIO2->FIOCLR0  = 0xff;
    			pGPIO2->FIOSET0 = BufferPtr[cnt++];
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
    			pGPIO4->FIOCLR = PINMASK(PIN_WR);
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");
                            asm volatile("nop");                        
    		}
    	}
    }

	return 0;
}


/* Check host buffer (FTDI245) for data */
int hal_host_if_is_char()
{

    	if( (LPC_GPIO2->FIOPIN & PINMASK(PIN_RXF)) == 0)
    	{
    		return 1;
    	}
    	else
    	{
    		return 0;
    	}
}	


/* Read character from host buffer (FTDI245) */
char hal_host_if_get_char(void)
{
	char cc;

    	LPC_GPIO2->FIODIR0 = 0x0;				
    	LPC_GPIO2->FIOCLR  = PINMASK(PIN_RD);	
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");	
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");	    
    	cc 	  = LPC_GPIO2->FIOPIN0; 		
    	LPC_GPIO2->FIOSET   = PINMASK(PIN_RD);	
    	LPC_GPIO2->FIODIR0 = 0xFF;				
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");	
    	asm volatile("nop");
    	asm volatile("nop");
    	asm volatile("nop");	    

    	return cc;
}




